int getItemIndex(string searched_value, string &compared_values[]) {
	for(int i = 0; i < ArraySize(compared_values); i++)
		if(compared_values[i] == searched_value) return i;
	return -1;
}

bool isInArray(string searched_value, string &compared_values[]) {
	return getItemIndex(searched_value, compared_values) >= 0;
}

bool isInArrayInt(int searched_value, int &compared_values[]) {
	for(int i = 0; i < ArraySize(compared_values); i++)
		if(compared_values[i] == searched_value) return (true);
	return (false);
}

void pushString(string value, string &storage[]) {
	ArrayResize(storage, ArraySize(storage) + 1);
	storage[ArraySize(storage) - 1] = value;
}

void pushInt(int value, int &storage[]) {
	ArrayResize(storage, ArraySize(storage) + 1);
	storage[ArraySize(storage) - 1] = value;
}

void pushDouble(double value, double &storage[]) {
	ArrayResize(storage, ArraySize(storage) + 1);
	storage[ArraySize(storage) - 1] = value;
}

void pushDateTime(datetime value, datetime &storage[]) {
	ArrayResize(storage, ArraySize(storage) + 1);
	storage[ArraySize(storage) - 1] = value;
}

double getSum(double &values[]) {
	double result = 0;
	for(int i = 0; i < ArraySize(values); i++)
		if(values[i] != EMPTY_VALUE) result = result + values[i];
	return (result);
}

double getAverageValue(double &values[]) {
	int non_empty_items_number = 0;
	for(int i = 0; i < ArraySize(values); i++)
		if(values[i] != EMPTY_VALUE) non_empty_items_number++;
		
	if(non_empty_items_number == 0) return 0;
	return (getSum(values) / non_empty_items_number);
}

double getMaximum(double &values[]) {
	if(ArraySize(values) < 1) return (0);
	double result = values[0];
	
	for(int i = 1; i < ArraySize(values); i++)
		if((values[i] != EMPTY_VALUE) && (values[i] > result)) result = values[i];
	return (result);
}

void setReverseArrayDouble(double &destination[], double &source[]) {
	ArrayResize(destination, ArraySize(source));
	for(int i = 0; i < ArraySize(source); i++)
		destination[ArraySize(destination) - 1 - i] = source[i];
}