#include <arrays.mqh>

bool isNumeric(string value) {
	int points_number = 0, point_position = -1, current_char;
	
	for(int i = 0; i < StringLen(value); i++) {
		current_char = StringGetChar(value, i);
		if(!isDigit(current_char) && (current_char != '.')) return(false);
		if(current_char == '.') {
			points_number++;
			point_position = i;
		}
	}
	
	return( (points_number <= 1) && ((point_position != 0) && (point_position != StringLen(value) - 1)) );
}

bool isInteger(string value) {
	for(int i = 1; i < StringLen(value); i++)
		if( !isDigit(StringGetChar(value, i)) ) return(false);
	return(true);
}

bool isDigit(int value) {
	return((value >= '0') && (value <= '9'));
}

string replace(string text, string search, string replacement) {
	for(int substring_position = StringFind(text, search); substring_position >= 0; substring_position = StringFind(text, search)) {
		//Language BUG e.g. StringSubstr("USDCAD", 0, 0) returns "USDCAD" instead of ""
		string first_chunk = "";
		if(substring_position > 0)
			first_chunk = StringSubstr(text, 0, substring_position);
		text = first_chunk + replacement + StringSubstr( text, substring_position + StringLen(search), StringLen(text) - (substring_position + StringLen(search)) );
	}
	
	return (text);
}

void split(string text, string delimiter, string& chunks[]) {
	ArrayResize(chunks, 0);
	int delimiter_position;
	for(delimiter_position = 0; StringFind(text, delimiter, delimiter_position) > 0; delimiter_position = StringFind(text, delimiter, delimiter_position) + 1)
		pushString(trim(StringSubstr(text, delimiter_position, StringFind(text, delimiter, delimiter_position) - delimiter_position)), chunks);
	pushString(trim(StringSubstr(text, delimiter_position, StringLen(text) - delimiter_position)), chunks);
}

string join(string &pieces[], string glue) {
	string result = "";
	
	for(int i = 0; i < ArraySize(pieces); i++) {
		if(i != 0) result = result + glue;
		result = result + pieces[i];
	}
	
	return (result);
}

string joinDoudle(double &pieces[], string glue) {
	string result = "";
	
	for(int i = 0; i < ArraySize(pieces); i++) {
		if(i != 0) result = result + glue;
		result = result + pieces[i];
	}
	
	return (result);
}

string joinInt(int &pieces[], string glue) {
	string result = "";
	
	for(int i = 0; i < ArraySize(pieces); i++) {
		if(i != 0) result = result + glue;
		result = result + pieces[i];
	}
	
	return (result);
}

string trim(string value) {
	return ( StringTrimLeft(StringTrimRight(value)) );
}

bool doesContain(string heap, string needle) {
	return (StringFind(heap, needle) >= 0);
}

string bool2str(bool value) {
	if(value) return ("true");
	return ("false");
}